<template>
  <div id="app">
    <ep-header></ep-header>
    <!--<ep-header-nav></ep-header-nav>-->
    <nuxt class="view" />
    <!--
    Show when there are 3+ options (e.g. profile, friends, messages, library)
    <ep-bottom-nav></ep-bottom-nav>
    -->
    <!-- Side Navs -->
    <ep-profile-sidenav :open="selectedSideNav === sideNavTypes.profile"></ep-profile-sidenav>
    <!-- Dialogs -->
    <ep-screen-overlay v-if="overlayVisible" v-on:hide="closeDialog()">
      <ep-menu-dialog v-if="selectedDialog === dialogTypes.menu"></ep-menu-dialog>
      <ep-media-dialog v-if="selectedDialog === dialogTypes.media"></ep-media-dialog>
      <ep-signin-dialog v-if="selectedDialog === dialogTypes.signin"></ep-signin-dialog>
      <ep-password-reset-dialog v-if="selectedDialog === dialogTypes.passwordReset"></ep-password-reset-dialog>
      <ep-signup-dialog v-if="selectedDialog === dialogTypes.signup"></ep-signup-dialog>
      <ep-welcome-dialog v-if="selectedDialog === dialogTypes.welcome"></ep-welcome-dialog>
      <ep-feedback-dialog v-if="selectedDialog === dialogTypes.feedback"></ep-feedback-dialog>
      <ep-verify-email-dialog v-if="selectedDialog === dialogTypes.verifyEmail"></ep-verify-email-dialog>
      <ep-are-you-sure-dialog v-if="selectedDialog === dialogTypes.areYouSure"></ep-are-you-sure-dialog>
      <ep-upload-pending-dialog v-if="selectedDialog === dialogTypes.uploadPending"></ep-upload-pending-dialog>
      <ep-upload-error-dialog v-if="selectedDialog === dialogTypes.uploadError"></ep-upload-error-dialog>
      <ep-message-dialog v-if="selectedDialog === dialogTypes.message"></ep-message-dialog>
    </ep-screen-overlay>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'

import Header from '~components/Header/Header'
import HeaderNav from '~components/Header/Nav'

import ProfileSideNav from '~components/SideNav/Profile'
import BottomNav from '~components/BottomNav'

import ScreenOverlay from '~components/ScreenOverlay'
import MenuDialog from '~components/Dialog/Menu'
import MediaDialog from '~components/Dialog/Media'
import SignInDialog from '~components/Dialog/SignIn'
import SignUpDialog from '~components/Dialog/SignUp'
import PasswordResetDialog from '~components/Dialog/PasswordReset'
import WelcomeDialog from '~components/Dialog/Welcome'
import FeedbackDialog from '~components/Dialog/Feedback'
import VerifyEmailDialog from '~components/Dialog/VerifyEmail'
import UploadPendingDialog from '~components/Dialog/UploadPending'
import UploadErrorDialog from '~components/Dialog/UploadError'
import MessageDialog from '~components/Dialog/Message'
import AreYouSureDialog from '~components/Dialog/AreYouSure'

import { getDeviceSettings } from '~/utils/device'
import stripeUtil from '~/utils/stripeUtil'

export default {
  name: 'app',
  components: {
    'ep-screen-overlay': ScreenOverlay,
    'ep-header': Header,
    'ep-header-nav': HeaderNav,

    'ep-profile-sidenav': ProfileSideNav,
    'ep-bottom-nav': BottomNav,

    'ep-menu-dialog': MenuDialog,
    'ep-media-dialog': MediaDialog,
    'ep-signin-dialog': SignInDialog,
    'ep-signup-dialog': SignUpDialog,
    'ep-password-reset-dialog': PasswordResetDialog,
    'ep-welcome-dialog': WelcomeDialog,
    'ep-feedback-dialog': FeedbackDialog,
    'ep-verify-email-dialog': VerifyEmailDialog,
    'ep-are-you-sure-dialog': AreYouSureDialog,

    'ep-upload-pending-dialog': UploadPendingDialog,
    'ep-upload-error-dialog': UploadErrorDialog,
    'ep-message-dialog': MessageDialog
  },
  data () {
    return { }
  },
  watch: {
    '$route': 'onRouteChange'
  },
  created () {
    this.initDeviceSettings()
  },
  mounted () {
    this.initProfile()
  },
  computed: {
    ...mapState('app', [
      'selectedDialog',
      'selectedSideNav',
      'dialogTypes',
      'sideNavTypes',
      'overlayVisible'
    ])
  },
  methods: {
    ...mapActions('app', [
      'closeDialog',
      'closeSideNav',
      'setDarkHeader',
      'resetShow404'
    ]),
    initProfile () {
      this.$store.dispatch('getProfileInfo')
    },
    initDeviceSettings () {
      this.$store.commit('SET_DEVICE_SETTINGS', getDeviceSettings())
    },
    onRouteChange () {
      this.closeDialog()
      this.closeSideNav()
      this.setDarkHeader(false)
      this.resetShow404()

      // Close stripe window on navigation
      if (stripeUtil && stripeUtil.handler) {
        stripeUtil.handler.close()
      }
    }
  }
}
</script>

<style>
html {
  height: 100%;
}
body {
  overflow-x: hidden;
  -webkit-overflow-scrolling: touch;
  min-height: 100%;
  margin: 0;
  /*font-family: Roboto,'HelveticaNeue-Light','Helvetica Neue Light','Helvetica Neue',Helvetica,Arial,sans-serif;*/
  font-family: 'Roboto', Helvetica, Arial, sans-serif;
  font-size: 14px;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

#app {
  height: 100%;
}
</style>
